//---------------------------------------------------------------
//------------------Safety-Stop for steppers---------------------
//---------------------------------------------------------------
void StepperStop() {

  //disable drivers
  setUmode(0);
  delay(20);
  setVmode(0);
  delay(20);
  setWmode(0);
  delay(20);
  setXmode(0);
  delay(20);
  setYmode(0);
  delay(20);
  setZmode(0);
  delay(500);
  digitalWrite(motorPowerEnable, LOW);
}



//---------------------------------------------------------------
//------------------Enable Stepper---------------------
//---------------------------------------------------------------
void StepperEnable() {

  digitalWrite(motorPowerEnable, HIGH);
  delay(500);
  //enable drivers with ramp-down
  if (stepperUactive == true) {
    setUmode(2);
    delay(200);
  }
  else {
    setUmode(0);
    delay(20);
  }



  if (stepperVactive == true) {
    setVmode(2);
    delay(200);
  }
  else {
    setVmode(0);
    delay(20);
  }


  if (stepperWactive == true) {
    setWmode(2);
    delay(200);
  }
  else {
    setWmode(0);
    delay(20);
  }


  if (stepperXactive == true) {
    setXmode(2);
    delay(200);
  }
  else {
    setXmode(0);
    delay(20);
  }

  if (stepperYactive == true) {
    setYmode(2);
    delay(200);
  }
  else {
    setYmode(0);
    delay(20);
  }

  if (stepperZactive == true) {
    setZmode(2);
    delay(200);
  }
  else {
    setZmode(0);
    delay(20);
  }

}




//----------------------------------------------------
//------------------Set Stepper mode-----------------
//----------------------------------------------------
/*
disable = 5V = 0
enable = GND = 1
RampDown = Open = 2

*/
void setUmode(int Umode) {
  switch (Umode) {
    case 0:
      digitalWrite (Uenable, LOW);
      delay(50);
      digitalWrite (Udisable, HIGH);
      break;

    case 1:
      digitalWrite (Udisable, LOW);
      delay(50);
      digitalWrite (Uenable, HIGH);
      break;

    case 2:
      digitalWrite (Udisable, LOW);
      digitalWrite (Uenable, LOW);
      break;
  }
}

void setVmode(int Vmode) {
  switch (Vmode) {
    case 0:
      digitalWrite (Venable, LOW);
      delay(50);
      digitalWrite (Vdisable, HIGH);
      break;

    case 1:
      digitalWrite (Vdisable, LOW);
      delay(50);
      digitalWrite (Venable, HIGH);
      break;

    case 2:
      digitalWrite (Vdisable, LOW);
      digitalWrite (Venable, LOW);
      break;
  }
}

void setWmode(int Wmode) {
  switch (Wmode) {
    case 0:
      digitalWrite (Wenable, LOW);
      delay(50);
      digitalWrite (Wdisable, HIGH);
      break;

    case 1:
      digitalWrite (Wdisable, LOW);
      delay(50);
      digitalWrite (Wenable, HIGH);
      break;

    case 2:
      digitalWrite (Wdisable, LOW);
      digitalWrite (Wenable, LOW);
      break;
  }
}

void setXmode(int Xmode) {
  switch (Xmode) {
    case 0:
      digitalWrite (Xenable, LOW);
      delay(50);
      digitalWrite (Xdisable, HIGH);
      break;

    case 1:
      digitalWrite (Xdisable, LOW);
      delay(50);
      digitalWrite (Xenable, HIGH);
      break;

    case 2:
      digitalWrite (Xdisable, LOW);
      digitalWrite (Xenable, LOW);
      break;
  }
}

void setYmode(int Ymode) {
  switch (Ymode) {
    case 0:
      digitalWrite (Yenable, LOW);
      delay(50);
      digitalWrite (Ydisable, HIGH);
      break;

    case 1:
      digitalWrite (Ydisable, LOW);
      delay(50);
      digitalWrite (Yenable, HIGH);
      break;

    case 2:
      digitalWrite (Ydisable, LOW);
      digitalWrite (Yenable, LOW);
      break;
  }
}
void setZmode(int Zmode) {
  switch (Zmode) {
    case 0:
      digitalWrite (Zenable, LOW);
      delay(50);
      digitalWrite (Zdisable, HIGH);
      break;

    case 1:
      digitalWrite (Zdisable, LOW);
      delay(50);
      digitalWrite (Zenable, HIGH);
      break;

    case 2:
      digitalWrite (Zdisable, LOW);
      digitalWrite (Zenable, LOW);
      break;
  }
}


//----------------------------------------------------
//------------------Set Stepper Current-----------------
//----------------------------------------------------
/*


  tmc_write(4, WRITE | REG_IHOLD_IRUN, 0x00021F1FUL); //IHOLD=100%, IRUN=100%
  tmc_write(4, WRITE | REG_IHOLD_IRUN, 0x00021F17UL); //IHOLD=31,3%, IRUN=100%


*/


//----------------------------------------------------
//------------------Set Stepper Resolution-----------------
//----------------------------------------------------

/*
  1:    1/1 spreadCycle  --> CFG1+CFG2 =GND
  2:    1/2 spreadCycle  --> CFG2 = GND
  4:    1/4 stealth      --> CFG1 = 5V(vcc)
  16:   1/16 stealth     --> open
  162:  1/16 spreadCycle --> CFG1 = GND
*/

/*
   full = 0x18008008UL
   1/2 = 0x17008008UL
   1/4 = 0x16008008UL
   1/8 = 0x15008008UL
   1/16 = 0x14008008UL
   1/32 = 0x13008008UL
   1/64 = 0x12008008UL
   1/128 = 0x11008008UL
   1/256 = 0x10008008UL
*/



void setUresolution(int Uresolution) {
  switch (Uresolution) {
    case 1:
      digitalWrite (Ucfg1vcc, LOW);
      delay(50);
      digitalWrite (Ucfg1gnd, HIGH);
      digitalWrite (Ucfg2gnd, HIGH);
      break;

    case 2:
      digitalWrite (Ucfg1vcc, LOW);
      digitalWrite (Ucfg1gnd, LOW);
      delay(50);
      digitalWrite (Ucfg2gnd, HIGH);
      break;

    case 4:
      digitalWrite (Ucfg1gnd, LOW);
      digitalWrite (Ucfg2gnd, LOW);
      delay(50);
      digitalWrite (Ucfg1vcc, HIGH);
      break;

    case 16:
      digitalWrite (Ucfg1gnd, LOW);
      digitalWrite (Ucfg2gnd, LOW);
      digitalWrite (Ucfg1vcc, LOW);
      break;
    case 162:
      digitalWrite (Ucfg2gnd, LOW);
      digitalWrite (Ucfg1vcc, LOW);
      delay(50);
      digitalWrite (Ucfg1gnd, HIGH);
      break;
  }
}

void setVresolution(int Vresolution) {
  switch (Vresolution) {
    case 1:
      digitalWrite (Vcfg1vcc, LOW);
      delay(50);
      digitalWrite (Vcfg1gnd, HIGH);
      digitalWrite (Vcfg2gnd, HIGH);
      break;

    case 2:
      digitalWrite (Vcfg1vcc, LOW);
      digitalWrite (Vcfg1gnd, LOW);
      delay(50);
      digitalWrite (Vcfg2gnd, HIGH);
      break;

    case 4:
      digitalWrite (Vcfg1gnd, LOW);
      digitalWrite (Vcfg2gnd, LOW);
      delay(50);
      digitalWrite (Vcfg1vcc, HIGH);
      break;

    case 16:
      digitalWrite (Vcfg1gnd, LOW);
      digitalWrite (Vcfg2gnd, LOW);
      digitalWrite (Vcfg1vcc, LOW);
      break;

    case 162:
      digitalWrite (Vcfg2gnd, LOW);
      digitalWrite (Vcfg1vcc, LOW);
      delay(50);
      digitalWrite (Vcfg1gnd, HIGH);
      break;
  }
}

void setWresolution(int Wresolution) {
  switch (Wresolution) {
    case 1:
      digitalWrite (Wcfg1vcc, LOW);
      delay(50);
      digitalWrite (Wcfg1gnd, HIGH);
      digitalWrite (Wcfg2gnd, HIGH);
      break;

    case 2:
      digitalWrite (Wcfg1vcc, LOW);
      digitalWrite (Wcfg1gnd, LOW);
      delay(50);
      digitalWrite (Wcfg2gnd, HIGH);
      break;

    case 4:
      digitalWrite (Wcfg1gnd, LOW);
      digitalWrite (Wcfg2gnd, LOW);
      delay(50);
      digitalWrite (Wcfg1vcc, HIGH);
      break;

    case 16:
      digitalWrite (Wcfg1gnd, LOW);
      digitalWrite (Wcfg2gnd, LOW);
      digitalWrite (Wcfg1vcc, LOW);
      break;

    case 162:
      digitalWrite (Wcfg2gnd, LOW);
      digitalWrite (Wcfg1vcc, LOW);
      delay(50);
      digitalWrite (Wcfg1gnd, HIGH);
      break;
  }
}

void setXresolution(int Xresolution) {
  switch (Xresolution) {
    case 1:
      digitalWrite (Xcfg1vcc, LOW);
      delay(50);
      digitalWrite (Xcfg1gnd, HIGH);
      digitalWrite (Xcfg2gnd, HIGH);
      break;

    case 2:
      digitalWrite (Xcfg1vcc, LOW);
      digitalWrite (Xcfg1gnd, LOW);
      delay(50);
      digitalWrite (Xcfg2gnd, HIGH);
      break;

    case 4:
      digitalWrite (Xcfg1gnd, LOW);
      digitalWrite (Xcfg2gnd, LOW);
      delay(50);
      digitalWrite (Xcfg1vcc, HIGH);
      break;

    case 16:
      digitalWrite (Xcfg1gnd, LOW);
      digitalWrite (Xcfg2gnd, LOW);
      digitalWrite (Xcfg1vcc, LOW);
      break;

    case 162:
      digitalWrite (Xcfg2gnd, LOW);
      digitalWrite (Xcfg1vcc, LOW);
      delay(50);
      digitalWrite (Xcfg1gnd, HIGH);
      break;
  }
}

void setYresolution(int Yresolution) {
  switch (Yresolution) {
    case 1:
      digitalWrite (Ycfg1vcc, LOW);
      delay(50);
      digitalWrite (Ycfg1gnd, HIGH);
    digitalWrite (Ycfg2gnd, HIGH);
      break;

    case 2:
      digitalWrite (Ycfg1vcc, LOW);
      digitalWrite (Ycfg1gnd, LOW);
      delay(50);
     digitalWrite (Ycfg2gnd, HIGH);
      break;

    case 4:
      digitalWrite (Ycfg1gnd, LOW);
     digitalWrite (Ycfg2gnd, LOW);
      delay(50);
      digitalWrite (Ycfg1vcc, HIGH);
      break;

    case 16:
      digitalWrite (Ycfg1gnd, LOW);
    digitalWrite (Ycfg2gnd, LOW);
      digitalWrite (Ycfg1vcc, LOW);
      break;

    case 162:
     digitalWrite (Ycfg2gnd, LOW);
      digitalWrite (Ycfg1vcc, LOW);
      delay(50);
      digitalWrite (Ycfg1gnd, HIGH);
      break;
  }
}

void setZresolution(int Zresolution) {
  switch (Zresolution) {
    case 1:
      digitalWrite (Zcfg1vcc, LOW);
      delay(50);
      digitalWrite (Zcfg1gnd, HIGH);
      digitalWrite (Zcfg2gnd, HIGH);
      break;

    case 2:
      digitalWrite (Zcfg1vcc, LOW);
      digitalWrite (Zcfg1gnd, LOW);
      delay(50);
      digitalWrite (Zcfg2gnd, HIGH);
      break;

    case 4:
      digitalWrite (Zcfg1gnd, LOW);
      digitalWrite (Zcfg2gnd, LOW);
      delay(50);
      digitalWrite (Zcfg1vcc, HIGH);
      break;

    case 16:
      digitalWrite (Zcfg1gnd, LOW);
      digitalWrite (Zcfg2gnd, LOW);
      digitalWrite (Zcfg1vcc, LOW);
      break;

    case 162:
      digitalWrite (Zcfg2gnd, LOW);
      digitalWrite (Zcfg1vcc, LOW);
      delay(50);
      digitalWrite (Zcfg1gnd, HIGH);
      break;
  }
}


//----------------------------------------------------
//---------------Move back to start position----------
//----------------------------------------------------

void moveBackToStartMovie() {


  AccelStepperU.setAcceleration(speedU / 2);
  AccelStepperV.setAcceleration(speedV / 2);
  AccelStepperW.setAcceleration(speedW / 2);
  AccelStepperX.setAcceleration(speedX / 2);
  AccelStepperY.setAcceleration(speedY / 2);
  AccelStepperZ.setAcceleration(speedZ / 2);

  AccelStepperU.moveTo(0);
  AccelStepperV.moveTo(0);
  AccelStepperW.moveTo(0);
  AccelStepperX.moveTo(0);
  AccelStepperY.moveTo(0);
  AccelStepperZ.moveTo(0);

  AccelStepperU.run();
  AccelStepperV.run();
  AccelStepperW.run();
  AccelStepperX.run();
  AccelStepperY.run();
  AccelStepperZ.run();


  if (AccelStepperU.distanceToGo() == 0 && AccelStepperV.distanceToGo() == 0 && AccelStepperW.distanceToGo() == 0 && AccelStepperX.distanceToGo() == 0 && AccelStepperY.distanceToGo() == 0 && AccelStepperZ.distanceToGo() == 0) {

    moveHomeMovie = false;


    if (movieFinished == true) {
      movieFinished = false;
      startMovie = false;
      StringSend = "#movieHome_0$";
      Serial1.print(StringSend);
    }
    else {
      posii = 0;

      accellX = videoMaxMoveSpeedX / videoPointUpdateTime;
      AccelStepperX.setAcceleration(accellX);

      accellY = videoMaxMoveSpeedY / videoPointUpdateTime;
      AccelStepperY.setAcceleration(accellY);

      accellZ = videoMaxMoveSpeedZ / videoPointUpdateTime;
      AccelStepperZ.setAcceleration(accellZ);

      accellU = videoMaxMoveSpeedU / videoPointUpdateTime;
      AccelStepperU.setAcceleration(accellU);

      accellV = videoMaxMoveSpeedV / videoPointUpdateTime;
      AccelStepperV.setAcceleration(accellV);

      accellW = videoMaxMoveSpeedW / videoPointUpdateTime;
      AccelStepperW.setAcceleration(accellW);

      timedurationVid = ((float)videoPointUpdateTime) / 100;
      startMovie = true;

    }


    previousMillisVidArray = millis();

  }
}
//----------------------------------------------------
//---------------Move back to start position----------
//----------------------------------------------------

void moveBackToStart() {

  AccelStepperU.setAcceleration(speedU / 2);
  AccelStepperV.setAcceleration(speedV / 2);
  AccelStepperW.setAcceleration(speedW / 2);
  AccelStepperX.setAcceleration(speedX / 2);
  AccelStepperY.setAcceleration(speedY / 2);
  AccelStepperZ.setAcceleration(speedZ / 2);

  AccelStepperU.run();
  AccelStepperV.run();
  AccelStepperW.run();
  AccelStepperX.run();
  AccelStepperY.run();
  AccelStepperZ.run();

  if (AccelStepperU.distanceToGo() == 0 && AccelStepperV.distanceToGo() == 0 && AccelStepperW.distanceToGo() == 0 && AccelStepperX.distanceToGo() == 0 && AccelStepperY.distanceToGo() == 0 && AccelStepperZ.distanceToGo() == 0) {
    movehome = false;
    myString = "0";
    StringSend = "#homeReached_" + myString + "$";
    Serial1.print(StringSend);
  }
}
//----------------------------------------------------
//---------------Move back to start position----------
//----------------------------------------------------

void moveToKeyframe() {


  AccelStepperU.setAcceleration(speedU / 2);
  AccelStepperV.setAcceleration(speedV / 2);
  AccelStepperW.setAcceleration(speedW / 2);
  AccelStepperX.setAcceleration(speedX / 2);
  AccelStepperY.setAcceleration(speedY / 2);
  AccelStepperZ.setAcceleration(speedZ / 2);


  AccelStepperU.run();
  AccelStepperV.run();
  AccelStepperW.run();
  AccelStepperX.run();
  AccelStepperY.run();
  AccelStepperZ.run();

  if (AccelStepperU.distanceToGo() == 0 && AccelStepperV.distanceToGo() == 0 && AccelStepperW.distanceToGo() == 0 && AccelStepperX.distanceToGo() == 0 && AccelStepperY.distanceToGo() == 0 && AccelStepperZ.distanceToGo() == 0) {
    moveKeyframe = false;

    myString = String(AccelStepperU.currentPosition());
    StringSend = "#curPosU_" + myString + "$";
    Serial1.print(StringSend);

    delay(40);
    myString = String(AccelStepperV.currentPosition());
    StringSend = "#curPosV_" + myString + "$";
    Serial1.print(StringSend);

    delay(40);
    myString = String(AccelStepperW.currentPosition());
    StringSend = "#curPosW_" + myString + "$";
    Serial1.print(StringSend);

    delay(40);
    myString = String(AccelStepperX.currentPosition());
    StringSend = "#curPosX_" + myString + "$";
    Serial1.print(StringSend);

    delay(40);
    myString = String(AccelStepperY.currentPosition());
    StringSend = "#curPosY_" + myString + "$";
    Serial1.print(StringSend);

    delay(40);
    myString = String(AccelStepperZ.currentPosition());
    StringSend = "#curPosZ_" + myString + "$";
    Serial1.print(StringSend);

    delay(40);
    myString = "0";
    StringSend = "#keyframeReached_" + myString + "$";
    Serial1.print(StringSend);
  }
}
//----------------------------------------------------
//---------------Speed settings----------
//----------------------------------------------------


void setMaxSpeedSteppers() {
  AccelStepperU.setMaxSpeed(speedU);
  AccelStepperV.setMaxSpeed(speedV);
  AccelStepperW.setMaxSpeed(speedW);
  AccelStepperX.setMaxSpeed(speedX);
  AccelStepperY.setMaxSpeed(speedY);
  AccelStepperZ.setMaxSpeed(speedZ);
}

void setSpeedFast() {
  AccelStepperU.setMaxSpeed(speedUsetFast);
  AccelStepperV.setMaxSpeed(speedVsetFast);
  AccelStepperW.setMaxSpeed(speedWsetFast);
  AccelStepperX.setMaxSpeed(speedXsetFast);
  AccelStepperY.setMaxSpeed(speedYsetFast);
  AccelStepperZ.setMaxSpeed(speedZsetFast);
}

void setSpeedSlow() {
  AccelStepperU.setMaxSpeed(speedUsetSlow);
  AccelStepperV.setMaxSpeed(speedVsetSlow);
  AccelStepperW.setMaxSpeed(speedWsetSlow);
  AccelStepperX.setMaxSpeed(speedXsetSlow);
  AccelStepperY.setMaxSpeed(speedYsetSlow);
  AccelStepperZ.setMaxSpeed(speedZsetSlow);
}

void backlashprocess() {
  AccelStepperX.setCurrentPosition(-1);
  AccelStepperX.setMaxSpeed(speedX);
  AccelStepperX.setAcceleration(speedX * 5);
  AccelStepperX.moveTo(-Xbacklash);
  long curposition = -1;
  
  while (curposition != 0) {
  
  
    AccelStepperX.run();
    curposition = AccelStepperX.currentPosition();
    if(curposition ==-Xbacklash){
       AccelStepperX.moveTo(0);
      }
  }


}