
//---------------------------------------------------------------
//-------------------------TIMELAPSE-----------------------------
//---------------------------------------------------------------
void timelapseMaster() {

  if (shotMode == 0) {
    ShotMoveShotMaster();
  }
  else {
    ShotMoveShotSlave();
  }
}


//-----------------------------------------------
//---------------Shot-move-shot Slave-----------
//-----------------------------------------------

void ShotMoveShotSlave() {
  AccelStepperU.moveTo(tempGerundetU);
  AccelStepperV.moveTo(tempGerundetV);
  AccelStepperW.moveTo(tempGerundetW);
  AccelStepperX.moveTo(tempGerundetX);
  AccelStepperY.moveTo(tempGerundetY);
  AccelStepperZ.moveTo(tempGerundetZ);

  AccelStepperU.setAcceleration(accelerationAmountU);
  AccelStepperU.run();

  AccelStepperV.setAcceleration(accelerationAmountV);
  AccelStepperV.run();

  AccelStepperW.setAcceleration(accelerationAmountW);
  AccelStepperW.run();

  AccelStepperX.setAcceleration(accelerationAmountX);
  AccelStepperX.run();

  AccelStepperY.setAcceleration(accelerationAmountY);
  AccelStepperY.run();

  AccelStepperZ.setAcceleration(accelerationAmountZ);
  AccelStepperZ.run();


  /*
    AccelStepperU.setSpeed(speedU);
    AccelStepperU.runSpeedToPosition();

    AccelStepperV.setSpeed(speedV);
    AccelStepperV.runSpeedToPosition();

    AccelStepperW.setSpeed(speedW);
    AccelStepperW.runSpeedToPosition();

    AccelStepperX.setSpeed(speedX);
    AccelStepperX.runSpeedToPosition();

    AccelStepperY.setSpeed(speedY);
    AccelStepperY.runSpeedToPosition();

    AccelStepperZ.setSpeed(speedZ);
    AccelStepperZ.runSpeedToPosition();
  */
  slaveTrigger = digitalRead(readCameraTrigger);

 
  //---------------------------------


  if (slaveTrigger != lastButtonState) {
    lastDebounceTime = millis();
  }

  if (slaveTouchbuttonClick == 1) {

    digitalWrite(dslrFocus, HIGH);
    digitalWrite(dslrTrigger, HIGH);
    currentPicNo++;

    myString = String(currentPicNo);
    StringSend = "#currentPicNo_" + myString + "$";
    Serial1.print(StringSend);

    delay(200);
    digitalWrite(dslrTrigger, LOW);
    digitalWrite(dslrFocus, LOW);

    delay(TLmaxexpo);

    if (currentPicNo > noMoveShots && currentPicNo <= (totalPicNo - noMoveShots)) {
      totalPicNoAKTmoveSpline++;
      moveSplineSMS();
    }

    slaveTouchbuttonClick = 0;
    myString = "0";
    StringSend = "#slaveActive_" + myString + "$";
    Serial1.print(StringSend);
  }



  if ((millis() - lastDebounceTime) > debounceDelay) {

    if (slaveTrigger != buttonState) {
      buttonState = slaveTrigger;

      if (buttonState == HIGH) {
        digitalWrite(dslrFocus, HIGH);
        digitalWrite(dslrTrigger, HIGH);
        currentPicNo++;

        myString = String(currentPicNo);
        StringSend = "#currentPicNo_" + myString + "$";
        Serial1.print(StringSend);

        delay(200);
        digitalWrite(dslrTrigger, LOW);
        digitalWrite(dslrFocus, LOW);

        delay(TLmaxexpo);

        if (currentPicNo > noMoveShots && currentPicNo <= (totalPicNo - noMoveShots)) {
          totalPicNoAKTmoveSpline++;
          moveSplineSMS();
        }


        slaveTouchbuttonClick = 0;
        myString = "0";
        StringSend = "#slaveActive_" + myString + "$";
        Serial1.print(StringSend);


      }
    }
  }

  lastButtonState = slaveTrigger;

}


//-----------------------------------------------
//---------------Shot-move-shot-----------
//-----------------------------------------------

void ShotMoveShotMaster() {
  unsigned long currentMillisSMS = millis();

  AccelStepperU.moveTo(tempGerundetU);
  AccelStepperV.moveTo(tempGerundetV);
  AccelStepperW.moveTo(tempGerundetW);
  AccelStepperX.moveTo(tempGerundetX);
  AccelStepperY.moveTo(tempGerundetY);
  AccelStepperZ.moveTo(tempGerundetZ);

  AccelStepperU.setAcceleration(accelerationAmountU);
  AccelStepperU.run();

  AccelStepperV.setAcceleration(accelerationAmountV);
  AccelStepperV.run();

  AccelStepperW.setAcceleration(accelerationAmountW);
  AccelStepperW.run();

  AccelStepperX.setAcceleration(accelerationAmountX);
  AccelStepperX.run();

  AccelStepperY.setAcceleration(accelerationAmountY);
  AccelStepperY.run();

  AccelStepperZ.setAcceleration(accelerationAmountZ);
  AccelStepperZ.run();
//Serial.print("TLTLT:");
//Serial.println(pauseTL);

  if (currentPicNo < totalPicNo) {

    if (currentMillisSMS  - previousMillis > SMSdauer  && pauseTL ==false)
    {
      SMSstep++;  // nächster Schritt
      switch (SMSstep)
      {
        case 1: //DSLR auslösen
          digitalWrite(dslrFocus, HIGH);
          digitalWrite(dslrTrigger, HIGH);
          currentPicNo++;

          myString = String(currentPicNo);
          StringSend = "#currentPicNo_" + myString + "$";
          Serial1.print(StringSend);

          voltage1 = analogRead(voltageRead1);
          voltage2 = analogRead(voltageRead2);

          SMSdauer = 200; // sec warten
          break;

        case 2: //Belichten und Warten
          digitalWrite(dslrTrigger, LOW);
          digitalWrite(dslrFocus, LOW);
          myString = String(voltage1);
          StringSend = "#voltage1_" + myString + "$";
          Serial1.print(StringSend);
          SMSdauer = TLmaxexpo;
          break;

        case 3: // Move

          if (currentPicNo > noMoveShots && currentPicNo <= (totalPicNo - noMoveShots)) {
            if(runinreverse==1){
                totalPicNoAKTmoveSpline--;
              }
              else{
            totalPicNoAKTmoveSpline++;
              }
            moveSplineSMS();
          }



          myString = String(voltage2);
          StringSend = "#voltage2_" + myString + "$";
          Serial1.print(StringSend);

          SMSdauer = 200;
          break;

        case 4: // Delay
          SMSdauer = TLdelay;
          break;

        default:
          // Serial.println(AccelStepperY.currentPosition());
          SMSstep = 0;
          SMSdauer = 1;     // Schrittfolge wieder von vorn
      }

      if(pauseTL==false){
      previousMillis = currentMillisSMS; // "Delay" neu starten
      }
    }  //  if (currentMillis  - previousMillis > Dauer )
  }
  else if (currentPicNo == totalPicNo && TLende == 0)
  {
    digitalWrite(dslrFocus, HIGH);
    digitalWrite(dslrTrigger, HIGH);
    delay(200);
    digitalWrite(dslrTrigger, LOW);
    digitalWrite(dslrFocus, LOW);
    TLende = 1;
    currentPicNo=0;
    totalPicNoAKTmoveSpline=0;
    startTL = false;
  }
  else {
    digitalWrite(dslrTrigger, LOW);
    digitalWrite(dslrFocus, LOW);
    TLende = 1;
   currentPicNo=0;
    totalPicNoAKTmoveSpline=0;
    startTL = false;
  }
}

//--------------------------------------------------------
//-------------------Accelstepper 3-axis TIMELAPSE--------
//--------------------------------------------------------

void moveSplineSMS() {

  float tempU = tempCurveU.value(totalPicNoAKTmoveSpline);
  float tempV = tempCurveV.value(totalPicNoAKTmoveSpline);
  float tempW = tempCurveW.value(totalPicNoAKTmoveSpline);
  float tempX = tempCurveX.value(totalPicNoAKTmoveSpline);
  float tempY = tempCurveY.value(totalPicNoAKTmoveSpline);
  float tempZ = tempCurveZ.value(totalPicNoAKTmoveSpline);

  tempGerundetU = long(tempU + 0.5);
  tempGerundetV = long(tempV + 0.5);
  tempGerundetW = long(tempW + 0.5);
  tempGerundetX = long(tempX + 0.5);
  tempGerundetY = long(tempY + 0.5);
  tempGerundetZ = long(tempZ + 0.5);
}







